#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <sys/ioctl.h>
#include <fcntl.h>

#include <errno.h>
#include <wiringPiSPI.h>
#include <wiringPiI2C.h>
#include <wiringPi.h>



#define CS1 27

void LS7366_Config(void);
void ReadEncoders(void);

int CS1_fd;
long int encoder1;

// channel is the wiringPi name for the chip select (or chip enable) pin.
// Set this to 0 or 1, depending on how it's connected.
static const int CHANNEL = 1;






int main(int argc, char* argv[])
{
  int fd, result, i;
  printf( " initializing ...\n" );

  // Configure the interface.
  // CHANNEL insicates chip select,
  // 1000000 indicates bus speed.
  fd = wiringPiSPISetup(CHANNEL, 1000000);
  printf( " Init result = %i \n", fd );   
      
  wiringPiSetupGpio();
  pinMode( CS1 , OUTPUT );
   
  LS7366_Config();
   

  for( i=0 ; i<10000 ; i++ ){
    ReadEncoders();
    printf( "encoder1 = %i \n", encoder1 );
    delay(1); 
  }
}





void LS7366_Config(void)
{
   char buff[2];
   buff[0] = 0x88;
   buff[1] = 0x03;
   
   CS1_fd = wiringPiSPISetup(CS1, 1000000);
   printf( "CS1 -> fd = %d \n", CS1_fd );
   
   // first
   digitalWrite( CS1 , LOW );
   write( CS1_fd , buff , 2 );
   digitalWrite( CS1 , HIGH );
   
}




void ReadEncoders(void)
{
   unsigned char buff[1];
   
   encoder1 = 0;
   
   // first encoder
   digitalWrite( CS1 , LOW );
   
   buff[0] = 0x60;  // reset count
   write( CS1_fd , buff , 1 );
   
   buff[0] = 0x00;  // read higher order byte
   wiringPiSPIDataRW( CS1_fd, buff, 1);
   encoder1 = (long int)buff[0] << 24;
   
   buff[0] = 0x00;  // read higher order byte
   wiringPiSPIDataRW( CS1_fd, buff, 1);
   encoder1 += (long int)buff[0] << 16;
   
   buff[0] = 0x00;  // read higher order byte
   wiringPiSPIDataRW( CS1_fd, buff, 1);
   encoder1 += (long int)buff[0] << 8;
   
   buff[0] = 0x00;  // read higher order byte
   wiringPiSPIDataRW( CS1_fd, buff, 1);
   encoder1 += (long int)buff[0];
   
   digitalWrite( CS1 , HIGH );
   
}



